Index: libcfs/libcfs/hash.c
===================================================================
RCS file: /cvsroot/cfs/libcfs/libcfs/hash.c,v
retrieving revision 1.1
diff -u -p -r1.1 hash.c
--- libcfs/libcfs/hash.c	1 Dec 2009 02:23:59 -0000	1.1
+++ libcfs/libcfs/hash.c	1 Jan 2010 20:03:33 -0000
@@ -86,13 +86,13 @@ cfs_hash_wunlock(cfs_hash_t *hs)
 }
 
 /**
- * Initialize new libcfs hash, where:
- * @name     - Descriptive hash name
- * @cur_bits - Initial hash table size, in bits
- * @max_bits - Maximum allowed hash table resize, in bits
- * @ops      - Registered hash table operations
- * @flags    - CFS_HASH_REHASH enable synamic hash resizing
- *           - CFS_HASH_SORT enable chained hash sort
+ * Initialize new libcfs hash.
+ * \param name     Descriptive hash name
+ * \param cur_bits Initial hash table size, in bits
+ * \param max_bits Maximum allowed hash table resize, in bits
+ * \param ops      Registered hash table operations
+ * \param flags    CFS_HASH_REHASH enables dynamic hash resizing;
+ *                 CFS_HASH_SORT enables chained hash sort
  */
 cfs_hash_t *
 cfs_hash_create(char *name, unsigned int cur_bits,
@@ -157,7 +157,7 @@ cfs_hash_create(char *name, unsigned int
 CFS_EXPORT_SYMBOL(cfs_hash_create);
 
 /**
- * Cleanup libcfs hash @hs.
+ * Cleanup libcfs hash \a hs.
  */
 void
 cfs_hash_destroy(cfs_hash_t *hs)
@@ -219,7 +219,7 @@ cfs_hash_rehash_bits(cfs_hash_t *hs)
 }
 
 /**
- * Add item @hnode to libcfs hash @hs using @key.  The registered
+ * Add item \a hnode to libcfs hash \a hs using \a key.  The registered
  * ops->hs_get function will be called when the item is added.
  */
 void
@@ -287,9 +287,9 @@ cfs_hash_findadd_unique_hnode(cfs_hash_t
 }
 
 /**
- * Add item @hnode to libcfs hash @hs using @key.  The registered
+ * Add item \a hnode to libcfs hash \a hs using \a key.  The registered
  * ops->hs_get function will be called if the item was added.
- * Returns 0 on success or -EALREADY on key collisions.
+ * \return 0 on success or -EALREADY on key collisions.
  */
 int
 cfs_hash_add_unique(cfs_hash_t *hs, void *key, struct hlist_node *hnode)
@@ -307,7 +307,7 @@ cfs_hash_add_unique(cfs_hash_t *hs, void
 CFS_EXPORT_SYMBOL(cfs_hash_add_unique);
 
 /**
- * Add item @hnode to libcfs hash @hs using @key.  If this @key
+ * Add item \a hnode to libcfs hash \a hs using \a key.  If this \a key
  * already exists in the hash then ops->hs_get will be called on the
  * conflicting entry and that entry will be returned to the caller.
  * Otherwise ops->hs_get is called on the item which was added.
@@ -328,7 +328,7 @@ cfs_hash_findadd_unique(cfs_hash_t *hs, 
 CFS_EXPORT_SYMBOL(cfs_hash_findadd_unique);
 
 /**
- * Delete item @hnode from the libcfs hash @hs using @key.  The @key
+ * Delete item \a hnode from the libcfs hash \a hs using \a key. The \a key
  * is required to ensure the correct hash bucket is locked since there
  * is no direct linkage from the item to the bucket.  The object
  * removed from the hash will be returned and obs->hs_put is called
@@ -360,9 +360,9 @@ cfs_hash_del(cfs_hash_t *hs, void *key, 
 CFS_EXPORT_SYMBOL(cfs_hash_del);
 
 /**
- * Delete item given @key in libcfs hash @hs.  The first @key found in
+ * Delete item given \a key in libcfs hash \a hs.  The first \a key found in
  * the hash will be removed, if the key exists multiple times in the hash
- * @hs this function must be called once per key.  The removed object
+ * \a hs this function must be called once per key.  The removed object
  * will be returned and ops->hs_put is called on the removed object.
  */
 void *
@@ -392,12 +392,12 @@ cfs_hash_del_key(cfs_hash_t *hs, void *k
 CFS_EXPORT_SYMBOL(cfs_hash_del_key);
 
 /**
- * Lookup an item using @key in the libcfs hash @hs and return it.
- * If the @key is found in the hash hs->hs_get() is called and the
+ * Lookup an item using \a key in the libcfs hash \a hs and return it.
+ * If the \a key is found in the hash hs->hs_get() is called and the
  * matching objects is returned.  It is the callers responsibility
  * to call the counterpart ops->hs_put using the cfs_hash_put() macro
- * when when finished with the object.  If the @key was not found
- * in the hash @hs NULL is returned.
+ * when when finished with the object.  If the \a key was not found
+ * in the hash \a hs NULL is returned.
  */
 void *
 cfs_hash_lookup(cfs_hash_t *hs, void *key)
@@ -426,8 +426,8 @@ cfs_hash_lookup(cfs_hash_t *hs, void *ke
 CFS_EXPORT_SYMBOL(cfs_hash_lookup);
 
 /**
- * For each item in the libcfs hash @hs call the passed callback @func
- * and pass to it as an argument each hash item and the private @data.
+ * For each item in the libcfs hash \a hs call the passed callback \a func
+ * and pass to it as an argument each hash item and the private \a data.
  * Before each callback ops->hs_get will be called, and after each
  * callback ops->hs_put will be called.  Finally, during the callback
  * the bucket lock is held so the callback must never sleep.
@@ -460,8 +460,8 @@ cfs_hash_for_each(cfs_hash_t *hs,
 CFS_EXPORT_SYMBOL(cfs_hash_for_each);
 
 /**
- * For each item in the libcfs hash @hs call the passed callback @func
- * and pass to it as an argument each hash item and the private @data.
+ * For each item in the libcfs hash \a hs call the passed callback \a func
+ * and pass to it as an argument each hash item and the private \a data.
  * Before each callback ops->hs_get will be called, and after each
  * callback ops->hs_put will be called.  During the callback the
  * bucket lock will not be held will allows for the current item
@@ -499,11 +499,11 @@ cfs_hash_for_each_safe(cfs_hash_t *hs,
 CFS_EXPORT_SYMBOL(cfs_hash_for_each_safe);
 
 /**
- * For each hash bucket in the libcfs hash @hs call the passed callback
- * @func until all the hash buckets are empty.  The passed callback @func
+ * For each hash bucket in the libcfs hash \a hs call the passed callback
+ * \a func until all the hash buckets are empty.  The passed callback \a func
  * or the previously registered callback hs->hs_put must remove the item
  * from the hash.  You may either use the cfs_hash_del() or hlist_del()
- * functions.  No rwlocks will be held during the callback @func it is
+ * functions.  No rwlocks will be held during the callback \a func it is
  * safe to sleep if needed.  This function will not terminate until the
  * hash is empty.  Note it is still possible to concurrently add new
  * items in to the hash.  It is the callers responsibility to ensure
@@ -540,10 +540,10 @@ restart:
 }
 CFS_EXPORT_SYMBOL(cfs_hash_for_each_empty);
 
-/*
- * For each item in the libcfs hash @hs which matches the @key call
- * the passed callback @func and pass to it as an argument each hash
- * item and the private @data.  Before each callback ops->hs_get will
+/**
+ * For each item in the libcfs hash \a hs which matches the \a key call
+ * the passed callback \a func and pass to it as an argument each hash
+ * item and the private \a data.  Before each callback ops->hs_get will
  * be called, and after each callback ops->hs_put will be called.
  * Finally, during the callback the bucket lock is held so the
  * callback must never sleep.
@@ -581,15 +581,15 @@ cfs_hash_for_each_key(cfs_hash_t *hs, vo
 CFS_EXPORT_SYMBOL(cfs_hash_for_each_key);
 
 /**
- * Rehash the libcfs hash @hs to the given @bits.  This can be used
+ * Rehash the libcfs hash \a hs to the given \a bits.  This can be used
  * to grow the hash size when excessive chaining is detected, or to
  * shrink the hash when it is larger than needed.  When the CFS_HASH_REHASH
- * flag is set in @hs the libcfs hash may be dynamically rehashed
+ * flag is set in \a hs the libcfs hash may be dynamically rehashed
  * during addition or removal if the hash's theta value exceeds
  * either the hs->hs_min_theta or hs->max_theta values.  By default
  * these values are tuned to keep the chained hash depth small, and
  * this approach assumes a reasonably uniform hashing function.  The
- * theta thresholds for @hs are tunable via cfs_hash_set_theta().
+ * theta thresholds for \a hs are tunable via cfs_hash_set_theta().
  */
 int
 cfs_hash_rehash(cfs_hash_t *hs, int bits)
@@ -696,9 +696,9 @@ cfs_hash_rehash(cfs_hash_t *hs, int bits
 CFS_EXPORT_SYMBOL(cfs_hash_rehash);
 
 /**
- * Rehash the object referenced by @hnode in the libcfs hash @hs.  The
- * @old_key must be provided to locate the objects previous location
- * in the hash, and the @new_key will be used to reinsert the object.
+ * Rehash the object referenced by \a hnode in the libcfs hash \a hs.  The
+ * \a old_key must be provided to locate the objects previous location
+ * in the hash, and the \a new_key will be used to reinsert the object.
  * Use this function instead of a cfs_hash_add() + cfs_hash_del()
  * combo when it is critical that there is no window in time where the
  * object is missing from the hash.  When an object is being rehashed
Index: libcfs/libcfs/libcfs_string.c
===================================================================
RCS file: /cvsroot/cfs/libcfs/libcfs/libcfs_string.c,v
retrieving revision 1.2
diff -u -p -r1.2 libcfs_string.c
--- libcfs/libcfs/libcfs_string.c	13 Mar 2009 08:17:27 -0000	1.2
+++ libcfs/libcfs/libcfs_string.c	1 Jan 2010 20:03:33 -0000
@@ -65,7 +65,38 @@ static int libcfs_strncasecmp(const char
         return tolower(*(unsigned char *)s1) - tolower(*(unsigned char *)s2);
 }
 
-/* Convert a text string to a bitmask */
+/**
+ * Convert a text string to a bitmask.
+ *
+ * The function initially sets \a newmask to \a minmask (starting
+ * point), then iterates over \a str looking for tokens or operators
+ * ('+' or '-') and updates \a newmask accordingly. When the whole \a
+ * str is parsed, \a newmask is stored in \a *oldmask. See inline
+ * comments inside implementation for details.
+ *
+ * The token is an arbitrary sub-string that doesn't contain
+ * white-spaces. Usually, the token is some descriptive word
+ * corresponding a bit. \a bit2str realizes this correspondence: \a
+ * bit2str(i) should return a string corresponding to the bit \a i.
+ *
+ * The word "ALL" is always valid token. When appears, forces
+ * \a newmask to be reinitialized (i.e. all previous tokens are
+ * effectively ignored):
+ * - to \a minmask if "ALL" is in scope of '-' operator
+ * - to \a allmask otherwise.
+ *
+ * \param str a list of tokens separated by whitespace
+ * \param bit2str a callback converting given bit to its string representation
+ * \param oldmask serves two-fold purpose:
+ * - as starting point if an operator appears in \a str prior any tokens
+ * - as storage for output of the function (\a newmask calculated)
+ * \param minmask starting point if no operators appear in \a str
+ * prior any tokens
+ * \param allmask mask corresponding to magic word 'ALL' in \a str
+ * \return 0 if OK, -EINVAL if error (\a str is misformatted)
+ *
+ * NOTE: tokens are case-insensitive.
+ */
 int libcfs_str2mask(const char *str, const char *(*bit2str)(int bit),
                     int *oldmask, int minmask, int allmask)
 {
@@ -129,7 +160,15 @@ int libcfs_str2mask(const char *str, con
         return 0;
 }
 
-/* Duplicate a string in a platform-independent way */
+/**
+ * Duplicate a string in a platform-independent way.
+ *
+ * \param str string to duplicate
+ * \param flags flags for libcfs memory allocator
+ * \return pointer to duplicated string or NULL if allocation failed
+ *
+ * NOTE: Must free with cfs_free().
+ */
 char *libcfs_strdup(const char *str, u_int32_t flags)
 {
         size_t lenz; /* length of str + zero byte */
Index: libcfs/libcfs/tracefile.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/libcfs/tracefile.h,v
retrieving revision 1.7
diff -u -p -r1.7 tracefile.h
--- libcfs/libcfs/tracefile.h	30 May 2009 14:51:50 -0000	1.7
+++ libcfs/libcfs/tracefile.h	1 Jan 2010 20:03:35 -0000
@@ -47,6 +47,58 @@
 #error Unsupported operating system.
 #endif
 
+/** \addtogroup libcfs
+ * @{
+ * \addtogroup libcfs_debug
+ * @{ */
+
+/**
+ * \defgroup libcfs_tracefile Tracefile subsystem
+ * Tracefile types and primitives
+ *
+ * Tracefile subsystem of Libcfs is a facility for in-kernel users
+ * allowing light-weight gathering log messages and dumping them to a
+ * file when requested.
+ *
+ * The core idea is to print debug messages in memory, into pre-allocated
+ * cpu-bound sets of kernel pages and initiate much more expensive
+ * dumping only when requested.
+ *
+ * Tracefile subsystem maintains global double-indexed array \a trace_data.
+ * The first index is so-called TCD type where "TCD" stands for "Trace CPU
+ * Data". This index reflects whether debug print happened in interrupt
+ * context or not. Such indexing is needed to handle nested prints
+ * properly. The second index is CPU number to avoid extra locking:
+ * for any given CPU number and interrupt level only one debug print
+ * may progress at any point in time. 
+ *
+ * The elements of \a trace_data array are essentially of \a trace_cpu_data
+ * type. This type nests the list of TCD pages (\a tcd_pages) of
+ * struct \a trace_page type. \a trace_page is a wrapper around kernel
+ * page adding some tracefile-specific info like how many bytes are
+ * already printed to this page.
+ *
+ * When a debug print is requested, tracefile subsystem just picks up
+ * proper element from \a trace_data array (based on current interrupt
+ * level and CPU number where the print occurred), gets a "tage" (TCD
+ * page) from the list (or allocates new tage if necessary) and
+ * prints out debug message into kernel page associated with the tage.
+ *
+ * To dump gathered logs on disk, tracefile subsystem firstly collects
+ * all tages into single list, then iterates over this list and writes
+ * the content of kernel pages associated with tages into file.
+ *
+ * The API that tracefile subsystem provides for the rest of Libcfs
+ * consist of four functions:
+ * - libcfs_debug_vmsg2 - to print debug message into tracefile buffers
+ * - tracefile_dump_all_pages - to save all gathered logs on disk
+ * - trace_flush_pages - to clear tracefile buffers (discard all gathered logs)
+ * - libcfs_assertion_failed - a helper to initiate LBUG (see
+ * \ref libcfs_assert for details)
+ *
+ * @{
+ */
+
 /* trace file lock routines */
 
 #define TRACEFILE_NAME_SIZE 1024
@@ -106,13 +158,14 @@ extern int  trace_max_debug_mb(void);
 
 #define TRACEFILE_SIZE (500 << 20)
 
-/* Size of a buffer for sprinting console messages if we can't get a page
+/** Size of a buffer for sprinting console messages if we can't get a page
  * from system */
 #define TRACE_CONSOLE_BUFFER_SIZE   1024
 
+/** Per-CPU trace data */
 union trace_data_union {
 	struct trace_cpu_data {
-		/*
+		/**
 		 * Even though this structure is meant to be per-CPU, locking
 		 * is needed because in some places the data may be accessed
 		 * from other CPUs. This lock is directly used in trace_get_tcd
@@ -122,14 +175,14 @@ union trace_data_union {
 		spinlock_t              tcd_lock;
 		unsigned long           tcd_lock_flags;
 
-		/*
+		/**
 		 * pages with trace records not yet processed by tracefiled.
 		 */
 		struct list_head        tcd_pages;
-		/* number of pages on ->tcd_pages */
+		/** number of pages on ->tcd_pages */
 		unsigned long           tcd_cur_pages;
 
-		/*
+		/**
 		 * pages with trace records already processed by
 		 * tracefiled. These pages are kept in memory, so that some
 		 * portion of log can be written in the event of LBUG. This
@@ -140,10 +193,10 @@ union trace_data_union {
 		 * discarded when list grows too large.
 		 */
 		struct list_head        tcd_daemon_pages;
-		/* number of pages on ->tcd_daemon_pages */
+		/** number of pages on ->tcd_daemon_pages */
 		unsigned long           tcd_cur_daemon_pages;
 
-		/*
+		/**
 		 * Maximal number of pages allowed on ->tcd_pages and
 		 * ->tcd_daemon_pages each.
 		 * Always TCD_MAX_PAGES * tcd_pages_factor / 100 in current
@@ -151,7 +204,7 @@ union trace_data_union {
 		 */
 		unsigned long           tcd_max_pages;
 
-		/*
+		/**
 		 * preallocated pages to write trace records into. Pages from
 		 * ->tcd_stock_pages are moved to ->tcd_pages by
 		 * portals_debug_msg().
@@ -174,13 +227,13 @@ union trace_data_union {
 		 * emitted in non-blocking contexts. Which is quite unlikely.
 		 */
 		struct list_head        tcd_stock_pages;
-		/* number of pages on ->tcd_stock_pages */
+		/** number of pages on ->tcd_stock_pages */
 		unsigned long           tcd_cur_stock_pages;
 
 		unsigned short          tcd_shutting_down;
 		unsigned short          tcd_cpu;
 		unsigned short          tcd_type;
-		/* The factors to share debug memory. */
+		/** The factors to share debug memory. */
 		unsigned short          tcd_pages_factor;
 	} tcd;
 	char __pad[L1_CACHE_ALIGN(sizeof(struct trace_cpu_data))];
@@ -201,9 +254,10 @@ extern union trace_data_union (*trace_da
 
 /* XXX nikita: this declaration is internal to tracefile.c and should probably
  * be moved there */
+/** collection of tages (trace data pages) */
 struct page_collection {
 	struct list_head        pc_pages;
-	/*
+	/**
 	 * spin-lock protecting ->pc_pages. It is taken by smp_call_function()
 	 * call-back functions. XXX nikita: Which is horrible: all processors
 	 * receive NMI at the same time only to be serialized by this
@@ -211,7 +265,7 @@ struct page_collection {
 	 * NR_CPUS elements accessed locklessly.
 	 */
 	spinlock_t              pc_lock;
-	/*
+	/**
 	 * if this flag is set, collect_pages() will spill both
 	 * ->tcd_daemon_pages and ->tcd_pages to the ->pc_pages. Otherwise,
 	 * only ->tcd_pages are spilled.
@@ -229,30 +283,30 @@ struct tracefiled_ctl {
 	atomic_t                tctl_shutdown;
 };
 
-/*
+/**
  * small data-structure for each page owned by tracefiled.
  */
 /* XXX nikita: this declaration is internal to tracefile.c and should probably
  * be moved there */
 struct trace_page {
-	/*
+	/**
 	 * page itself
 	 */
 	cfs_page_t      *page;
-	/*
+	/**
 	 * linkage into one of the lists in trace_data_union or
 	 * page_collection
 	 */
 	struct list_head linkage;
-	/*
+	/**
 	 * number of bytes used within this page
 	 */
 	unsigned int     used;
-	/*
+	/**
 	 * cpu that owns this page
 	 */
 	unsigned short   cpu;
-	/*
+	/**
 	 * type(context) of this page
 	 */
 	unsigned short   type;
@@ -319,7 +373,7 @@ int tcd_owns_tage(struct trace_cpu_data 
 extern void trace_assertion_failed(const char *str, const char *fn,
 				   const char *file, int line);
 
-/* ASSERTION that is safe to use within the debug system */
+/** ASSERTION that is safe to use within the debug system */
 #define __LASSERT(cond)                                                 \
     do {                                                                \
         if (unlikely(!(cond))) {                                        \
@@ -339,3 +393,7 @@ extern void trace_assertion_failed(const
 #endif	/* LUSTRE_TRACEFILE_PRIVATE */
 
 #endif /* __LIBCFS_TRACEFILE_H__ */
+
+/** @} libcfs_tracefile */
+/** @} libcfs_debug */
+/** @} libcfs */
Index: libcfs/libcfs/user-bitops.c
===================================================================
RCS file: /cvsroot/cfs/libcfs/libcfs/user-bitops.c,v
retrieving revision 1.4
diff -u -p -r1.4 user-bitops.c
--- libcfs/libcfs/user-bitops.c	7 Aug 2008 14:48:51 -0000	1.4
+++ libcfs/libcfs/user-bitops.c	1 Jan 2010 20:03:35 -0000
@@ -40,6 +40,17 @@
 
 #define OFF_BY_START(start)     ((start)/BITS_PER_LONG)
 
+/**
+ * Find first non-zero bit in bitmask pointed by \a addr starting from
+ * a bit specified by \a offset.
+ *
+ * \param addr Points to bitmask
+ * \param size Size of bitmask (in bits)
+ * \param offset # bits to skip prior search
+ *
+ * \return \a size if failed to find non-zero bit, position of
+ * non-zero bit (counting from 0) otherwise
+ */
 unsigned long find_next_bit(unsigned long *addr,
                             unsigned long size, unsigned long offset)
 {
@@ -74,6 +85,17 @@ found:
         return base + bit;
 }
 
+/**
+ * Find first zero bit in bitmask pointed by \a addr starting from
+ * a bit specified by \a offset.
+ *
+ * \param addr Points to bitmask
+ * \param size Size of bitmask (in bits)
+ * \param offset # bits to skip prior search
+ *
+ * \return \a size if failed to find zero bit, position of
+ * zero bit (counting from 0) otherwise
+ */
 unsigned long find_next_zero_bit(unsigned long *addr,
                                  unsigned long size, unsigned long offset)
 {
Index: libcfs/libcfs/user-lock.c
===================================================================
RCS file: /cvsroot/cfs/libcfs/libcfs/user-lock.c,v
retrieving revision 1.14
diff -u -p -r1.14 user-lock.c
--- libcfs/libcfs/user-lock.c	27 May 2009 02:40:38 -0000	1.14
+++ libcfs/libcfs/user-lock.c	1 Jan 2010 20:03:35 -0000
@@ -42,10 +42,9 @@
 
 /*
  * liblustre is single-threaded, so most "synchronization" APIs are trivial.
- *
- * XXX Liang: There are several branches share lnet with b_hd_newconfig,
- * if we define lock APIs at here, there will be conflict with liblustre
- * in other branches.
+ * However, to test liblustre on commodity h/w, we still need liblustre running
+ * in MT environment. In this case lnet and LNDs need some part of API to be
+ * MT-safe. See the code under HAVE_LIBPTHREAD below.
  */
 
 #ifndef __KERNEL__
Index: libcfs/libcfs/user-mem.c
===================================================================
RCS file: /cvsroot/cfs/libcfs/libcfs/user-mem.c,v
retrieving revision 1.5
diff -u -p -r1.5 user-mem.c
--- libcfs/libcfs/user-mem.c	7 Oct 2008 04:14:11 -0000	1.5
+++ libcfs/libcfs/user-mem.c	1 Jan 2010 20:03:35 -0000
@@ -53,6 +53,12 @@
  * Allocator
  */
 
+/* XXX Maxim: This is a bug that user-space cfs_alloc_pages returns
+ * only one page for order != 0, not array of pages. Fortunately, nobody
+ * calls it with order !=0. This will be fixed soon by removing
+ * cfs_alloc_pages/cfs_free_pages entirely from libcfs */
+
+/** return page with pre-allocated CFS_PAGE_SIZE * 2^order bytes of memory */
 cfs_page_t *cfs_alloc_pages(int mask, unsigned long order)
 {
         cfs_page_t *pg = malloc(sizeof(*pg));
@@ -127,6 +133,15 @@ void cfs_kunmap(cfs_page_t *pg)
  * SLAB allocator
  */
 
+/**
+ * Create memory cache (SLAB allocator)
+ *
+ * \param name some descriptive name of cache
+ * \param objsize size of objects in this cache
+ * \param off not used
+ * \param flags not used
+ * \return ptr to the cache on success, NULL on failure
+ */
 cfs_mem_cache_t *
 cfs_mem_cache_create(const char *name, size_t objsize, size_t off, unsigned long flags)
 {
@@ -160,9 +175,8 @@ void cfs_mem_cache_free(cfs_mem_cache_t 
 
 /**
  * Returns true if \a addr is an address of an allocated object in a slab \a
- * kmem. Used in assertions. This check is optimistically imprecise, i.e., it
- * occasionally returns true for the incorrect addresses, but if it returns
- * false, then the addresses is guaranteed to be incorrect.
+ * kmem. Used in assertions. Dummy implementation (always return 1) is
+ * OK because it's also imprecise on other platforms.
  */
 int cfs_mem_is_in_cache(const void *addr, const cfs_mem_cache_t *kmem)
 {
Index: libcfs/libcfs/user-tcpip.c
===================================================================
RCS file: /cvsroot/cfs/libcfs/libcfs/user-tcpip.c,v
retrieving revision 1.7
diff -u -p -r1.7 user-tcpip.c
--- libcfs/libcfs/user-tcpip.c	3 Feb 2009 13:43:18 -0000	1.7
+++ libcfs/libcfs/user-tcpip.c	1 Jan 2010 20:03:35 -0000
@@ -82,6 +82,17 @@ libcfs_sock_ioctl(int cmd, unsigned long
         return rc;
 }
 
+/**
+ * Query interface for its IP-address and status (up/down).
+ *
+ * \param name String with name of interface to query
+ * \param up On successful return, status of interface is saved here.
+ * 1 if "up", 0 if "down".
+ * \param ip On successful return, IP-address of interface is saved
+ * here (in host byte-order).
+ *
+ * \return 0 if OK, negative error code otherwise
+ */
 int
 libcfs_ipif_query (char *name, int *up, __u32 *ip)
 {
@@ -143,6 +154,20 @@ libcfs_ipif_free_enumeration (char **nam
         LIBCFS_FREE(names, n * sizeof(*names));
 }
 
+/**
+ * Builds array of names of all known IP-interfaces.
+ *
+ * The caller usually defines a variable of (char **) type and passes
+ * its address as \a namesp. Upon successful return, the variable will
+ * be updated pointing at the array of strings (every slot in the
+ * array is the name of some IP-interface). The array must be freed after
+ * use by means of libcfs_ipif_free_enumeration.
+ *
+ * \param namesp On successful return, the address of array of names
+ * is saved here.
+ *
+ * \return # elements in the array if OK, negative error code otherwise
+ */
 int
 libcfs_ipif_enumerate (char ***namesp)
 {
@@ -237,6 +262,19 @@ libcfs_ipif_enumerate (char ***namesp)
  * Network functions used by user-land lnet acceptor
  */
 
+/**
+ * Create cfs_socket, bind it and start listening.
+ *
+ * Created socket must be freed after use by means of libcfs_sock_release.
+ *
+ * \param sockp On successful return, the address of newly created
+ * socket is saved here.
+ * \param local_ip IP-address to bind socket to
+ * \param local_port TCP port to bind socket to
+ * \param backlog maxim number of outstanding connection requests allowed
+ *
+ * \return 0 if OK, negative error code otherwise
+ */
 int
 libcfs_sock_listen (cfs_socket_t **sockp,
                     __u32 local_ip, int local_port, int backlog)
@@ -269,6 +307,17 @@ libcfs_sock_release (cfs_socket_t *sock)
         LIBCFS_FREE(sock, sizeof(cfs_socket_t));
 }
 
+/**
+ * Create cfs_socket, accept incoming TCP connection
+ *
+ * Created socket must be freed after use by means of libcfs_sock_release.
+ *
+ * \param newsockp On successful return, the address of newly created
+ * socket (end-point of newly accepted TCP-connection) is saved here.
+ * \param sock Socket where consumer is listening
+ *
+ * \return 0 if OK, negative error code otherwise
+ */
 int
 libcfs_sock_accept (cfs_socket_t **newsockp, cfs_socket_t *sock)
 {
@@ -294,6 +343,21 @@ libcfs_sock_accept (cfs_socket_t **newso
         return 0;
 }
 
+/**
+ * Read data from the socket
+ *
+ * \param sock Socket to read data from
+ * \param buffer Buffer to store data
+ * \param nob # bytes to read
+ * \param timeout Maximum time interval (in seconds) before return -ETIMEDOUT
+ *
+ * \return 0 if OK, negative error code otherwise
+ *
+ * NOTE: If remote end-point closes connection before \a nob bytes
+ * read, the function returns -EIO.
+ *
+ * \pre \a sock should be in non-blocking mode (libcfs_fcntl_nonblock)
+ */
 int
 libcfs_sock_read (cfs_socket_t *sock, void *buffer, int nob, int timeout)
 {
@@ -341,6 +405,23 @@ libcfs_sock_read (cfs_socket_t *sock, vo
                 return -ETIMEDOUT;
 }
 
+/**
+ * Write data to the socket
+ *
+ * \param sock Socket to write data to
+ * \param buffer Source buffer
+ * \param nob # bytes to write
+ * \param timeout Maximum time interval (in seconds) before return -ETIMEDOUT
+ *
+ * \return 0 if OK, negative error code otherwise
+ *
+ * NOTE: If poll(2) indicated that write is possible (the socket is
+ * not flow-controlled anymore) but write(2) returned zero, the
+ * function regards it as unexpected erroneous situation and returns
+ * -EIO.
+ *
+ * \pre \a sock should be in non-blocking mode (libcfs_fcntl_nonblock)
+ */
 int
 libcfs_sock_write (cfs_socket_t *sock, void *buffer, int nob, int timeout)
 {
@@ -388,7 +469,7 @@ libcfs_sock_write (cfs_socket_t *sock, v
                 return -ETIMEDOUT;
 }
 
-/* Just try to connect to localhost to wake up entity that are
+/** Just try to connect to localhost to wake up entity that are
  * sleeping in accept() */
 void
 libcfs_sock_abort_accept(cfs_socket_t *sock)
@@ -453,6 +534,21 @@ libcfs_sock_getaddr(cfs_socket_t *sock, 
  * Network functions of common use
  */
 
+/**
+ * Create an unnamed pair of connected sockets in the AF_UNIX domain
+ *
+ * Created sockets (\a sockp[0] and \a sockp[1]) must be freed after
+ * use by means of libcfs_sock_release.
+ *
+ * \param sockp On successful return, the addresses of newly created
+ * connected sockets are saved here (in sockp[0] and \a sockp[1]).
+ *
+ * NOTE: It's responsibility of caller to allocate (and free after use
+ * if needed) an array of two pointers to cfs_socket_t. The caller passes
+ * the address of this array as \a sockp argument in this function.
+ *
+ * \return 0 if OK, negative error code otherwise
+ */
 int
 libcfs_socketpair(cfs_socket_t **sockp)
 {
@@ -495,6 +591,7 @@ libcfs_socketpair(cfs_socket_t **sockp)
         return 0;
 }
 
+/** Switch socket to non-blocking mode */
 int
 libcfs_fcntl_nonblock(cfs_socket_t *sock)
 {
@@ -517,6 +614,8 @@ libcfs_fcntl_nonblock(cfs_socket_t *sock
         return 0;
 }
 
+/** Enable Nagle's algorithm on socket. See TCP/IP docs about
+ * TCP_NODELAY option for details */
 int
 libcfs_sock_set_nagle(cfs_socket_t *sock, int nagle)
 {
@@ -540,6 +639,7 @@ libcfs_sock_set_nagle(cfs_socket_t *sock
         return 0;
 }
 
+/** Set both receive and send buffer sizes on socket */
 int
 libcfs_sock_set_bufsiz(cfs_socket_t *sock, int bufsiz)
 {
@@ -568,6 +668,7 @@ libcfs_sock_set_bufsiz(cfs_socket_t *soc
         return 0;
 }
 
+/** Bind given socket to \a ip / \a port */
 int
 libcfs_sock_bind(cfs_socket_t *sock, __u32 ip, __u16 port)
 {
@@ -593,6 +694,24 @@ libcfs_sock_bind(cfs_socket_t *sock, __u
         return 0;
 }
 
+/**
+ * Create TCP socket and bind it to \a local_ip / \a local_port
+ *
+ * The failure to create and bind may be fatal or not as the function
+ * indicates storing one or zero in \a fatal. For now, any failure
+ * related to creation is treated as fatal, while any failure to bind
+ * is treated as not fatal.
+ *
+ * Created socket must be freed after use by means of libcfs_sock_release.
+ *
+ * \param sockp On successful return, the address of newly created
+ * connected socket is saved here.
+ * \param fatal Points to a flag where "fatality" of operation to be saved
+ * \param local_ip IP-address to bind socket to
+ * \param local_port TCP-port to bind socket to
+ *
+ * \return 0 if OK, negative error code otherwise
+ */
 int
 libcfs_sock_create(cfs_socket_t **sockp, int *fatal,
                    __u32 local_ip, int local_port)
@@ -636,6 +755,19 @@ libcfs_sock_create(cfs_socket_t **sockp,
         return rc;
 }
 
+/**
+ * Connect socket to \a ip / \a port
+ *
+ * The function assumes that \a sock is in non-blocking mode. So, EINPROGRESS
+ * error from connect(2) is treated as "success" and the function returns 0
+ * in this case.
+ *
+ * \param sock Socket to connect
+ * \param ip IP-address of remote peer to connect to
+ * \param port TCP-port of remote peer to connect to
+ *
+ * \return 0 if OK, negative error code otherwise
+ */
 int
 libcfs_sock_connect(cfs_socket_t *sock, __u32 ip, __u16 port)
 {
@@ -661,10 +793,16 @@ libcfs_sock_connect(cfs_socket_t *sock, 
         return 0;
 }
 
-/* NB: EPIPE and ECONNRESET are considered as non-fatal
+/**
+ * Scatter-gather write to socket
+ *
+ * NB: EPIPE and ECONNRESET are considered as non-fatal
  * because:
- * 1) it still makes sense to continue reading &&
- * 2) anyway, poll() will set up POLLHUP|POLLERR flags */
+ * - it still makes sense to continue reading
+ * - anyway, poll() will set up POLLHUP|POLLERR flags
+ *
+ * NB: the function wraps writev in syscall(2) to bypass libsysio
+ */
 int
 libcfs_sock_writev(cfs_socket_t *sock, const struct iovec *vector, int count)
 {
@@ -687,6 +825,11 @@ libcfs_sock_writev(cfs_socket_t *sock, c
         return rc;
 }
 
+/**
+ * Scatter-gather read from socket
+ *
+ * NB: the function wraps readv in syscall(2) to bypass libsysio
+ */
 int
 libcfs_sock_readv(cfs_socket_t *sock, const struct iovec *vector, int count)
 {
